//IRCOM Group - A. Layec

//REVISION HISTORY :
// $Log$

//Script for generate all palettes of modnum
//suppose that macro libraries of scicos blocks
//are already build

lines(0);
getf(MODNUM+'/macros/build_util/generate_palette.sci');
getf(MODNUM+'/macros/build_util/build_lib.sci');

//Build and load signal macro library
build_lib('/macros/signal','mod_num_signal');
mod_num_signal=lib(MODNUM+'/macros/signal/');
//Load scicos_block libraries
pal=['Communication';'Filter';'NonLinear';'Pll';'Sinks';'Sources';'Tools';'Old';'OldSinks'];
pal_name=['com';'filter';'nonlinear';'pll';'sinks';'sources';'tools';'old';'oldsinks'];
rep_pal='/macros/scicos_blocks/'+pal+'/';
tt=[];
for i=1:size(rep_pal,'*')
  tt=[tt;'mod_num_'+pal_name(i)+'_pal=lib(MODNUM+'''+rep_pal(i)+''');'];
end
execstr(tt,'errcatch');
clear tt

for i=1:size(rep_pal,"*")
  files_sci=basename(listfiles(MODNUM+rep_pal(i)+"*.sci"));
  //18/03/07 : patch to properly sort communication blocks
  if pal(i)=='Communication' then
    kk=[];
    kk=[kk,find(files_sci=='MODQAM_f')]
    kk=[kk,find(files_sci=='DEMODQAM_f')]
    kk=[kk,find(files_sci=='MODPSK_f')]
    kk=[kk,find(files_sci=='DEMODPSK_f')]
    jj=find(files_sci<>'DEMODQAM_f'&...
            files_sci<>'DEMODPSK_f'&...
            files_sci<>'MODQAM_f'&...
            files_sci<>'MODPSK_f')
   files_sci=[files_sci(kk);files_sci(jj)];
   clear kk; clear jj,
  end
  generate_palette(files_sci,MODNUM+'/macros/scicos_blocks/',pal(i));
end
clear i