//return_dir_list
//fonction qui retourne le contenu d'un rpertoire
//sous formes d'une liste
//Entre : 
//path un vecteur de chane de caractre de chemin
//Sortie :
//ttl une liste
//ttl()(1) : le nom du chemin examin (absolu)
//ttl()(2) : un vecteur de chanes de caractres des noms de fichiers
//ttl()(3) : un vecteur de chanes de caractres des noms de rpertoires
//           (sans chemin) (ex: ['man';'macros']
function ttl=return_dir_list(path)
ttl=list();
if path<>[] then
 p=size(path,1);
 for j=1:p
     tt_sub=return_dir_name(path(j))
     tt_fil=return_fil_name(path(j))
     if MSDOS then
       path(j)=pathconvert(path(j),%t,%t,'w')
     else
       path(j)=pathconvert(path(j),%t,%t,'u')
     end
     ttl(j)=list(path(j),tt_fil,tt_sub);
 end
end
endfunction 
