/* teb Scicos block
 * Type 2 simulation function ver 1.0 - scilab-2.6&2.7
 * 28 janvier 2004 - IRCOM GROUP - Author : A.Layec
 */

/* REVISION HISTORY :
 * $Log$
 */

#include "machine.h"

/* Cette fonction est un compteur qui incrmente par pas de 1 
 * chaque fois que u<>0.
 *
 * Entre rgulire : u : Signal d'entre
 * Sortie rgulire : y : signal de sortie
 * Entre vnementielle : nant
 * Sortie vnementielle : nant
 *
 * Paramtres entier :     insz[0] : taille du vecteur en entre
 *
 * tat discret      :     z[0] : compteur
 */

/*prototype*/
void teb(flag,nevprt,t,xd,x,nx,z,nz,tvec,ntvec,rpar,nrpar,
         ipar,nipar,inptr,insz,nin,outptr,outsz,nout)
integer *flag,*nevprt,*nx,*nz,*ntvec,*nrpar,ipar[],*nipar,insz[],*nin,outsz[],*nout;
double x[],xd[],z[],tvec[],rpar[];
double *inptr[],*outptr[],*t;
{
  /*dclaration des variables*/
  double *y;
  double *u;
  int nu,i;

  /*rcupration des adresses des ports rguliers*/
  y=(double *)outptr[0];
  u=(double *)inptr[0];

  /*rcupration du nombre d'chantillon*/
  nu=insz[0];

  /*Le flag 1 calcul z et place la valeur de z dans y*/
  if(*flag==1)
    {
      for(i=0;i<nu;i++)
        {
         if(u[i]!=0) z[0]++;
        }
      y[0]=z[0];
    }
}
