/* d : code utilitaire pour calculer
 * la taille du mot de travail ncessaire  fftmx
 *
 * 25/03/2007 : netoyage du code
 *
 */

/* REVISION HISTORY :
 * $Log$
 */

/* d.f -- translated by f2c (version 20041007).
 * You must link the resulting object file with libf2c:
 * on Microsoft Windows system, link with libf2c.lib;
 * on Linux or Unix systems, link with .../path/to/libf2c.a -lm
 * or, if you install libf2c.a in a standard place, with -lf2c -lm
 * -- in that order, at the end of the command line, as in
 * cc *.o -lf2c -lm
 * Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,
 *
 * http://www.netlib.org/f2c/libf2c.zip
 */

#include "f2c.h"

/* Subroutine d
 *
 * Entre :
 *    n : taille de la tf
 *
 * Sorties :
 *    n_work : taille du tableau de travail
 *    ierr   : numro d'erreur
 */

int d(integer *n, integer *n_work, integer *ierr)
{
  /* Initialized data */

  /* System generated locals */
  integer i__1, i__2, i__3;

  /* Local variables */
  static integer j, k, m, jj, kt, kkk, nfac[15], maxf,
                 maxp, ntot, nspan, nitems, istkgt;

  *ierr = 0;

  /* determine the factors of n */
  m = 0;

  k = abs(*n);
  if ( k == 1) {
    return 0;
  }

  nspan = (i__1 = k , abs(i__1));
  ntot = (i__1 = nspan , abs(i__1));

  if (ntot == 0) {
    *ierr = 1;
    return 0;
  }

  while (k - (k / 16 << 4) == 0) {
    ++m;
    nfac[m - 1] = 4;
    k /= 16;
  }
  j = 3;
  jj = 9;
L40:
  while (k % jj == 0) {
    ++m;
    nfac[m - 1] = j;
    k /= jj;
  }
  j += 2;
  /* Computing 2nd power */
  jj = j * j;
  if (jj <= k) {
    goto L40;
  }
  if (k > 4) {
    goto L50;
  }
  kt = m;
  nfac[m] = k;
  if (k != 1) {
    ++m;
  }
  goto L90;
L50:
  if (k - (k / 4 << 2) == 0) {
    ++m;
    nfac[m - 1] = 2;
    k /= 4;
  }
  /* all square factors out now, but k .ge. 5 still */
  kt = m;
  /* Computing MAX */
  i__1 = kt + kt + 2, i__2 = k - 1;
  maxp = max(i__1,i__2);
  j = 2;
L70:
  if (k % j != 0) {
    goto L80;
  }
  ++m;
  nfac[m - 1] = j;
  k /= j;
L80:
  j = ((j + 1) / 2 << 1) + 1;
  if (j <= k) {
    goto L70;
  }
L90:
  if (m <= kt + 1) {
    maxp = m + kt + 1;
  }
  if (m + kt > 15) {
    *ierr = 2;
    return 0;
  }

  if (kt != 0) {
    j = kt;
    ++m;
    nfac[m - 1] = nfac[j - 1];
    --j;
    while (j != 0) {
      ++m;
      nfac[m - 1] = nfac[j - 1];
      --j;
    }
  }

  maxf = m - kt;
  maxf = nfac[maxf - 1];
  if (kt > 0) {
    i__1 = nfac[kt - 1];
    maxf = max(i__1,maxf);
  }

  for (kkk = 1; kkk <= m; ++kkk) {
    /* Computing MAX */
    i__2 = maxf, i__3 = nfac[kkk - 1];
    maxf = max(i__2,i__3);
  }

  /*nitems = maxf << 2;*/
  istkgt = (10 - 1) / 2 + 2;
  *n_work = ((istkgt - 1 + (maxf << 2)) * 2 - 1) + 3;

  /*nitems = maxp; */
  istkgt = ((*n_work) - 1) + 2;
  *n_work = ((istkgt - 1 + maxp) - 1) + 3;

  return 0;
} /* d_ */

