/* complex_test : bibliothque utilitaire
 * pour manipuler des nombres complexes
 * IRCOM Group - Alan
 */

/* REVISION HISTORY :
 * $Log$
 */

#include <stdio.h>

#include "scicos_block.h"

typedef struct {double real;double imag;} complex;
typedef struct {double *real;double *imag;int sz;} complex_tab;
typedef struct {double *adr;int sz;} complex_tab2;

double real(complex myvar){return(myvar.real);}
double imag(complex myvar){return(myvar.imag);}

complex cmplx(double real,double imag)
{
  complex myvar;
  myvar.real=real;
  myvar.imag=imag;
  return(myvar);
}

complex add_cmplx(complex myvar1, complex myvar2)
{
 complex myvar;
 myvar.real=myvar1.real+myvar2.real;
 myvar.imag=myvar1.imag+myvar2.imag;
 return(myvar);
}

complex mul_cmplx(complex myvar1, complex myvar2)
{
 complex myvar;
 myvar.real=myvar1.real*myvar2.real-myvar1.imag*myvar2.imag;
 myvar.imag=myvar1.real*myvar2.imag+myvar1.imag*myvar2.real;
 return(myvar);
}

complex_tab cmplx_tab(double *real, double *imag, int sz)
{ 
  complex_tab myvar;
  myvar.real=real;
  myvar.imag=imag;
  myvar.sz=sz;
  return(myvar);
}

void complex_test(scicos_block *block,int flag)
{
 complex myvar;
 complex_tab var;

 myvar = cmplx(block->inptr[0][0],block->inptr[0][1]);
 var = cmplx_tab(&block->inptr[0][0],&block->inptr[0][1],1);

 if(flag==2)
 {

 }
 else if(flag==1)
 {
  block->outptr[0][0] = real(myvar);
  block->outptr[0][1] = imag(myvar);
 }
}
